package com.cedarsoft.spring.rcp;

import org.jetbrains.annotations.NotNull;

/**
 * Creates a new bean
 *
 * @param <T> the type of bean this factory is able to create
 */
public interface BeanFactory<T> {
  /**
   * Creates a new bean
   *
   * @return the created bean
   */
  @NotNull
  T createNewBean();
}