package com.cedarsoft.spring.rcp;

import com.cedarsoft.spring.rcp.TabProvider;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import org.springframework.richclient.dialog.AbstractDialogPage;
import org.springframework.richclient.dialog.DialogPage;

import javax.swing.JComponent;

/**
 * Provides a tab with containing a component
 */
public class ComponentTabProvider implements TabProvider {
  @NotNull
  private final JComponent component;
  @NotNull
  @NonNls
  private final String pageId;

  /**
   * Creates a new tab provider
   *
   * @param pageId    the page id
   * @param component the component
   */
  public ComponentTabProvider( @NotNull String pageId, @NotNull JComponent component ) {
    this.pageId = pageId;
    this.component = component;
  }

  @Override
  @NotNull
  public DialogPage createTab() {
    return new AbstractDialogPage( pageId ) {
      @Override
      protected JComponent createControl() {
        return component;
      }
    };
  }
}
