package com.cedarsoft.spring.rcp.beans.factory;

import com.cedarsoft.history.ObservableObjectAccess;
import com.cedarsoft.spring.rcp.dialog.BeanFormDialogFactory;
import com.cedarsoft.spring.rcp.dialog.FormDialogFactory;
import org.jetbrains.annotations.NotNull;

/**
 * UI Factory for business objects.
 * This factory is configured using a {@link UiAccessBuilderConfiguration}.
 * <p/>
 * This factory works based on extended tables, properties dialogs and views.
 * It should be the right thing for most of the default beans
 *
 * @param <T> the type
 */
public class DefaultDialogBasedUiAccessBuilder<T> extends DialogBasedUiAccessBuilder<T> {
  public DefaultDialogBasedUiAccessBuilder( @NotNull AbstractConfiguration<T> configuration ) {
    super( configuration );
  }

  @Override
  @NotNull
  protected FormDialogFactory<T> createDefaultPropertiesDialogFactory() {
    return new BeanFormDialogFactory<T>( getIdStrategy(), getConfiguration().getBeanFactory(), configuration.getFormFactory() );
  }

  @NotNull
  @Override
  public UiAccessBuilderConfiguration<T> getConfiguration() {
    return ( UiAccessBuilderConfiguration<T> ) super.getConfiguration();
  }
}
