package com.cedarsoft.spring.rcp.beans.view;

import com.cedarsoft.spring.SpringSupport;
import com.cedarsoft.spring.rcp.beans.BeansDisplay;
import com.cedarsoft.SwingHelper;
import com.cedarsoft.lookup.Lookup;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 * Opens a view based on a defined view descriptor.
 */
public class ViewBasedBeansDisplay implements BeansDisplay {
  @NotNull
  @NonNls
  private final String viewDescriptorId;

  /**
   * Creates a new display
   * @param viewDescriptorId the descriptor id
   */
  public ViewBasedBeansDisplay( @NonNls @NotNull String viewDescriptorId ) {
    this.viewDescriptorId = viewDescriptorId;
  }

  @Override
  public void show( @NotNull Lookup context ) {
    SwingHelper.assertEventThread();
    SpringSupport.INSTANCE.getActiveApplicationWindow().getPage().showView( viewDescriptorId );
  }
}
