package com.cedarsoft.spring.rcp.binding;

import com.cedarsoft.spring.rcp.binding.ContinuousEntriesInformationPanel;
import com.cedarsoft.history.ContinuousEntriesInformation;
import com.cedarsoft.history.ContinuousEntry;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import org.springframework.binding.form.FormModel;
import org.springframework.richclient.form.binding.support.AbstractBinding;

import javax.swing.JComponent;

/**
 *
 */
public class ContinuousInformationBinding<I extends ContinuousEntriesInformation<E>, E extends ContinuousEntry> extends AbstractBinding {
  @NotNull
  private final ContinuousEntriesInformationPanel<E> panel;

  public ContinuousInformationBinding( @NotNull Class<I> informationType, @NotNull ContinuousEntriesInformationPanel<E> panel, @NotNull FormModel formModel, @NotNull @NonNls String formPropertyPath ) {
    super( formModel, formPropertyPath, informationType );
    this.panel = panel;
  }

  @Override
  protected JComponent doBindControl() {
    panel.setContinuousEntriesInformation( ( ContinuousEntriesInformation<E> ) getValue() );
    return panel;
  }

  @Override
  protected void readOnlyChanged() {
  }

  @Override
  protected void enabledChanged() {
  }
}