package com.cedarsoft.spring.rcp.binding;

import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import org.springframework.binding.form.FormModel;

/**
 * Implementations decide whether a fiven property of a model is nullable or not
 */
public interface NullableSupport {
  /**
   * Returns whether the given property path for the model is nullable
   *
   * @param formModel        the model
   * @param formPropertyPath the path
   * @return whether this property is nullable
   */
  boolean isNullable( @NotNull FormModel formModel, @NotNull @NonNls String formPropertyPath );
}