package com.cedarsoft.spring.rcp.binding;

import com.cedarsoft.history.ObservableObjectAccess;
import com.cedarsoft.spring.rcp.tbpanel.ObjectTablePanelFactory;
import org.jetbrains.annotations.NotNull;
import org.springframework.binding.form.FormModel;
import org.springframework.richclient.form.binding.Binding;
import org.springframework.richclient.form.binding.support.AbstractBinder;

import javax.swing.JComponent;
import javax.swing.JLabel;
import java.util.Map;

/**
 * Multi binder based on a object table panel.
 * The property bound by this binder must be of type {@link ObservableObjectAccess}
 *
 * @param <T> the type
 */
public class ObjectTablePanelMultiBinder<T> extends AbstractBinder {
  @NotNull
  private final ObjectTablePanelFactory<T> objectTablePanelFactory;

  public ObjectTablePanelMultiBinder( @NotNull ObjectTablePanelFactory<T> objectTablePanelFactory ) {
    super( ObservableObjectAccess.class );
    this.objectTablePanelFactory = objectTablePanelFactory;
  }

  @Override
  protected JComponent createControl( Map context ) {
    return new JLabel( "dummy" );
  }

  @Override
  protected Binding doBind( JComponent control, FormModel formModel, String formPropertyPath, Map context ) {
    return new ObjectTablePanelMultiBinding<T>( formPropertyPath, formModel, objectTablePanelFactory );
  }
}
