package com.cedarsoft.spring.rcp.commands;

import org.jetbrains.annotations.NotNull;
import org.springframework.richclient.command.ActionCommand;

/**
 * Provides a command for a given object
 *
 * @param <T> the type of the object the command is provided for
 */
public interface CommandProvider<T> {
  /**
   * Returns the command
   *
   * @param object the object
   * @return the command for the given object
   */
  @NotNull
  ActionCommand getCommand( @NotNull T object );
}