package com.cedarsoft.spring.rcp.conversion;

import org.jetbrains.annotations.NotNull;
import org.springframework.binding.convert.Converter;
import org.springframework.binding.convert.support.GenericConversionService;

import java.util.List;

/**
 * A custom conversion service that contains a chain of converters.
 */
public class ChainedConversionService extends GenericConversionService {
  /**
   * @param converters the converters
   */
  public void setConverters( @NotNull List<? extends Converter> converters ) {
    getSourceClassConverters().clear();

    for ( Converter converter : converters ) {
      addConverter( converter );
    }
  }
}
