package com.cedarsoft.spring.rcp.conversion;

import org.joda.time.LocalDate;
import org.joda.time.format.DateTimeFormat;
import org.springframework.binding.convert.ConversionContext;
import org.springframework.binding.convert.support.ConversionServiceAwareConverter;

/**
 *
 */
public class String2DateTimeConverter extends ConversionServiceAwareConverter {
  @Override
  protected Object doConvert( Object source, Class targetClass, ConversionContext context ) throws Exception {
    if ( !targetClass.equals( LocalDate.class ) ) {
      throw new IllegalStateException( "Cannot convert to  " + targetClass.getName() );
    }

    if ( source instanceof String ) {
      return DateTimeFormat.shortDate().parseDateTime( ( String ) source );
    }

    throw new IllegalStateException( "Cannot convert " + source );
  }

  @Override
  public Class[] getSourceClasses() {
    return new Class[]{String.class};
  }


  @Override
  public Class[] getTargetClasses() {
    return new Class[]{LocalDate.class};
  }
}
