package com.cedarsoft.spring.rcp.creation;

import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 * Creates a creator model
 *
 * @param <T> the type
 */
public interface CreatorModelFactory<T> {
  /**
   * Creates the creator model
   *
   * @param formId the form id
   * @return the creator model
   */
  @NotNull
  CreatorModel<T> createCreatorModel( @NotNull @NonNls String formId );
}
