package com.cedarsoft.spring.rcp.events;

import org.jetbrains.annotations.NotNull;
import org.springframework.context.ApplicationEvent;

/**
 *
 */
public class ApplicationAlertEvent extends ApplicationEvent {
  @NotNull
  private final String message;
  @NotNull
  private final EventType eventType;

  public ApplicationAlertEvent( @NotNull EventType eventType, @NotNull String message, @NotNull Object source ) {
    super( source );
    this.message = message;
    this.eventType = eventType;
  }

  @NotNull
  public String getMessage() {
    return message;
  }

  public boolean isErrorEvent() {
    return eventType == EventType.ERROR;
  }

  public boolean isWarningEvent() {
    return eventType == EventType.WARNING;
  }

  public boolean isInfoEvent() {
    return eventType == EventType.INFO;
  }

  public enum EventType {
    INFO,
    WARNING,
    ERROR
  }
}
