package com.cedarsoft.spring.rcp.exception;

import com.cedarsoft.spring.rcp.events.ApplicationAlertEvent;
import org.jetbrains.annotations.NotNull;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.richclient.exceptionhandling.AbstractLoggingExceptionHandler;

/**
 *
 */
public class InternalEventExceptionHandler extends AbstractLoggingExceptionHandler implements ApplicationContextAware {
  private ApplicationContext context;

  @Override
  public void setApplicationContext( @NotNull ApplicationContext applicationContext ) throws BeansException {
    this.context = applicationContext;
  }

  @Override
  public void notifyUserAboutException( @NotNull Thread thread, @NotNull Throwable throwable ) {
    ApplicationAlertEvent event = new ApplicationAlertEvent( ApplicationAlertEvent.EventType.ERROR, throwable.getLocalizedMessage(), throwable );
    context.publishEvent( event );
  }
}
