package com.cedarsoft.spring.rcp.forms;

import com.cedarsoft.spring.rcp.creation.CreatorModel;
import com.cedarsoft.ObjectAdd;
import org.jetbrains.annotations.NotNull;

/**
 * Static creator based form backend
 *
 * @param <T> the type
 */
public class CreatorFormBackend<T> extends AbstractStaticFormBackend<T> {
  @NotNull
  private final ObjectAdd<T> objectAdd;

  /**
   * Creates a new form backend
   *
   * @param formModel the form model
   * @param objectAdd the object add that is used to add the created object
   */
  public CreatorFormBackend( @NotNull CreatorModel<T> formModel, @NotNull ObjectAdd<T> objectAdd ) {
    super( formModel );
    this.objectAdd = objectAdd;
  }

  @NotNull
  @Override
  public CreatorModel<T> getFormModel() {
    return ( CreatorModel<T> ) super.getFormModel();
  }

  @Override
  public void commit() {
    objectAdd.add( getFormModel().getFormObject() );
  }
}
