package com.cedarsoft.spring.rcp.forms;

import org.jetbrains.annotations.NotNull;
import org.springframework.binding.form.FormModel;

/**
 * Creates forms
 *
 * @param <T> the type the this factory creates forms for
 */
public interface FormFactory<T> {
  /**
   * Creates a form for the given model
   *
   * @param formModel the model
   * @return the created form
   */
  @NotNull
  ExtendedForm<? extends T> createForm( @NotNull FormModel formModel );
}