package com.cedarsoft.spring.rcp.forms;

import org.jetbrains.annotations.NotNull;
import org.springframework.richclient.dialog.DialogPage;
import org.springframework.richclient.dialog.FormBackedDialogPage;
import org.springframework.richclient.form.Form;
import com.cedarsoft.spring.rcp.TabProvider;

/**
 * Provides a tab containing a form
 */
public class FormTabProvider implements TabProvider {
  @NotNull
  private final Form form;

  public FormTabProvider( @NotNull Form form ) {
    this.form = form;
  }

  @Override
  @NotNull
  public DialogPage createTab() {
    return new FormBackedDialogPage( form );
  }
}
