package com.cedarsoft.spring.rcp.hierarchy;

import com.cedarsoft.lookup.Lookup;
import org.jetbrains.annotations.NotNull;

/**
 */
public interface HierarchyLayer<P, C> {
  /**
   * Returns the lookup that contains several implementations
   *
   * @return the lookup
   */
  @NotNull
  Lookup getLookup();

  /**
   * Is called when a parent of the layer has been changed
   *
   * @param parent the parent that has been changed
   */
  void handleModified( @NotNull Object parent );
}
