package com.cedarsoft.spring.rcp.id;

import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 * Implementations provides IDs for business object ui components
 */
public interface IdStrategy {
  /**
   * Returns the base id
   *
   * @return the base id
   */
  @NotNull
  @NonNls
  String getBaseId();

  /**
   * Creates the table id
   *
   * @return the table id
   */
  @NotNull
  @NonNls
  String createTableId();

  /**
   * Creates the dialog id
   *
   * @return the dialog id
   */
  @NotNull
  @NonNls
  String createDialogId();

  /**
   * Creates the form id
   *
   * @return the form id
   */
  @NotNull
  @NonNls
  String createFormId();

  /**
   * Creates the table panel id
   *
   * @return the table panel id
   */
  @NotNull
  @NonNls
  String createTablePanelId();

  /**
   * Creates the view id
   *
   * @return the view id
   */
  @NotNull
  @NonNls
  String createViewId();

  /**
   * Creates the editor id
   *
   * @return the editor id
   */
  @NotNull
  @NonNls
  String createEditorId();
}