package com.cedarsoft.spring.rcp.joda;

import org.jetbrains.annotations.NotNull;
import org.joda.time.format.PeriodFormatter;
import org.joda.time.format.PeriodFormatterBuilder;

/**
 *
 */
public class JodaSupport {
  private JodaSupport() {
  }

  @NotNull
  public static final PeriodFormatter PERIOD_FORMAT;

  static {
    PeriodFormatterBuilder builder = new PeriodFormatterBuilder(); //todo i18n
    builder.appendYears().appendSuffix( " Jahr", " Jahre" ).appendSeparator( ", " )
            .appendMonths().appendSuffix( " Monat", " Monate" ).appendSeparator( ", " )
            .appendDays().appendSuffix( " Tag", " Tage" ).appendSeparator( ", " )
            .printZeroAlways().minimumPrintedDigits( 2 ).appendHours().appendSeparator( ":" )
            .appendMinutes().appendSeparator( ":" )
            .printZeroRarelyLast().appendSeconds()
            ;
    PERIOD_FORMAT = builder.toFormatter();
  }
}
