package com.cedarsoft.spring.rcp.prefetch;

import org.jetbrains.annotations.NotNull;

import java.util.Collection;

/**
 * Prefetches an object (from the cluster)
 *
 * @param <T> the object prefetcher
 */
public interface ObjectPrefetcher<T> {
  /**
   * Whether this prefetcher is responsible for the given object
   *
   * @param object the object
   * @return whether this prefetcher is responsible for the given object
   */
  boolean isResponsible( @NotNull Object object );

  /**
   * Prefetch the given object
   *
   * @param object the object that is prefetched
   * @return other objects that should be prefetched, too
   */
  @NotNull
  Collection<? extends Object> prefetch( @NotNull T object );
}
