package com.cedarsoft.spring.rcp.renderer;

import org.jetbrains.annotations.NotNull;

import java.text.DateFormat;
import java.util.Date;

/**
 *
 */
public class DateLabelProvider extends DefaultLabelProvider<Date> {
  @NotNull
  private final DateFormat dateFormat;

  public DateLabelProvider() {
    this( DateFormat.getDateInstance( DateFormat.SHORT ) );
  }

  public DateLabelProvider( @NotNull DateFormat dateFormat ) {
    this.dateFormat = dateFormat;
  }

  @NotNull
  @Override
  protected String getLabelFor( @NotNull Date item ) {
    return dateFormat.format( item );
  }
}
