package com.cedarsoft.spring.rcp.rules;

import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import org.springframework.rules.constraint.Constraint;
import org.springframework.rules.constraint.property.PropertyConstraint;
import org.springframework.rules.support.DefaultRulesSource;

/**
 * Offers some extended rule methods
 */
public class ExtendedRulesSource extends DefaultRulesSource {
  @Override
  @NotNull
  public Constraint all( @NotNull Constraint... predicates ) {
    return super.all( predicates );
  }

  @Override
  @NotNull
  public PropertyConstraint all( @NotNull @NonNls String propertyName, @NotNull Constraint... constraints ) {
    return super.all( propertyName, constraints );
  }

  @Override
  @NotNull
  public Constraint any( @NotNull Constraint... constraints ) {
    return super.any( constraints );
  }

  @NotNull
  protected Constraint getNameValueConstraint() {
    return all( required(), minLength( 3 ), maxLength( 35 ) );
  }

  @NotNull
  protected Constraint getLongNameValueConstraint() {
    return all( required(), minLength( 3 ), maxLength( 80 ) );
  }
}
