package com.cedarsoft.spring.rcp.table;

import ca.odell.glazedlists.SortedList;
import ca.odell.glazedlists.EventList;
import org.jetbrains.annotations.NotNull;

/**
 * Creates the final event list for the object table
 *
 * @param <T> the type
 */
public interface FinalEventListFactory<T> {
  /**
   * Creates the final event list
   *
   * @param baseEventList the base event list
   * @return the final event list
   */
  @NotNull
  EventList<T> create( @NotNull SortedList<T> baseEventList );
}