package com.cedarsoft.spring.rcp.table.renderer;

import org.jetbrains.annotations.NotNull;
import org.springframework.richclient.selection.binding.support.LabelProvider;

/**
 * A table cell renderer that uses a label provider
 *
 * @param <T> the type
 */
public class LabelProviderBasedCellRenderer<T> extends AbstractTableCellRenderer<T> {
  @NotNull
  private final LabelProvider labelProvider;

  public LabelProviderBasedCellRenderer( @NotNull Class<T> type, @NotNull LabelProvider labelProvider ) {
    this( type, labelProvider, false );
  }

  public LabelProviderBasedCellRenderer( @NotNull Class<T> type, @NotNull LabelProvider labelProvider, boolean alignRight ) {
    super( type, alignRight );
    this.labelProvider = labelProvider;
  }

  @NotNull
  @Override
  protected String format( @NotNull T object ) {
    return labelProvider.getLabel( object );
  }
}
