package com.cedarsoft.spring.rcp.table.renderer;

import com.cedarsoft.spring.rcp.table.renderer.AbstractTableCellRenderer;
import com.cedarsoft.spring.rcp.joda.JodaSupport;
import org.jetbrains.annotations.NotNull;
import org.joda.time.Period;

/**
 * Period cell renderer
 */
public class PeriodCellRenderer extends AbstractTableCellRenderer<Period> {
  public PeriodCellRenderer() {
    super( Period.class );
  }

  @Override
  @NotNull
  protected String format( @NotNull Period object ) {
    return JodaSupport.PERIOD_FORMAT.print( object );
  }
}
