package com.cedarsoft.spring.rcp.table.renderer;

import com.cedarsoft.utils.tags.Tag;
import com.cedarsoft.utils.tags.Tagged;
import org.jetbrains.annotations.NotNull;

import java.util.Iterator;

/**
 *
 */
public class TaggedCellRenderer extends AbstractTableCellRenderer<Tagged> {
  public TaggedCellRenderer() {
    super( Tagged.class );
  }

  @Override
  @NotNull
  protected String format( @NotNull Tagged object ) {
    StringBuilder builder = new StringBuilder();
    for ( Iterator<? extends Tag> it = object.getTags().iterator(); it.hasNext(); ) {
      Tag tag = it.next();
      builder.append( tag );
      if ( it.hasNext() ) {
        builder.append( ", " );
      }
    }

    return builder.toString();
  }
}