package com.cedarsoft.spring.rcp.tbpanel.aspects;

import org.jetbrains.annotations.NotNull;
import com.cedarsoft.history.ObservableObjectAccess;
import com.cedarsoft.spring.rcp.beans.BeanAgent;
import com.cedarsoft.lookup.Lookups;

import javax.swing.JComponent;

/**
 * Default editor
 *
 * @param <T> the type
 */
public class DefaultEditor<T> implements EditableAspect.Editor<T> {
  @NotNull
  private final ObservableObjectAccess<T> objectAccess;
  @NotNull
  private final JComponent parent;
  @NotNull
  private final BeanAgent<T> agent;

  /**
   * Creates a new default editor
   *
   * @param agent        the agent
   * @param objectAccess the object access
   * @param parent        the panel
   */
  public DefaultEditor( @NotNull BeanAgent<T> agent, @NotNull ObservableObjectAccess<T> objectAccess, @NotNull JComponent parent ) {
    this.objectAccess = objectAccess;
    this.parent = parent;
    this.agent = agent;
  }

  @Override
  public void editEntry( @NotNull T selectedObject ) {
    agent.edit( objectAccess, selectedObject, Lookups.dynamicLookup( parent ) );
  }
}
