package com.cedarsoft.spring.rcp.tbpanel.config;

import com.cedarsoft.spring.rcp.table.ExtendedObjectTable;
import com.cedarsoft.spring.rcp.table.ObjectTable;
import org.jetbrains.annotations.NotNull;

/**
 * Interface that configures an object table within the context of the configurer.
 *
 * @param <T> the type
 */
public interface ObjectTableConfigurer<T> {
  /**
   * Configures the table
   *
   * @param objectTable the table
   */
  void configurePreShow( @NotNull ObjectTable<T> objectTable );

  /**
   * Is called after the table has been shown
   *
   * @param objectTable the table
   */
  void configurePostShow( @NotNull ObjectTable<T> objectTable );
}
