package com.cedarsoft.spring.rcp.tree;

import com.cedarsoft.history.ObservableCollection;
import org.jetbrains.annotations.NotNull;

/**
 * Provides the children for an object
 *
 * @param <P> the type of the parent
 * @param <C> the type of the children
 */
public interface ChildProvider<P, C> {
  /**
   * Provides the children for the given parent
   *
   * @param parent the parent
   * @return the children
   */
  @NotNull
  ObservableCollection<C> getChildren( @NotNull P parent );
}