package com.cedarsoft.spring.rcp.tree;

import org.jetbrains.annotations.NotNull;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

/**
 * An extended tree model based on mutable tree nodes.
 */
public class ExtendedTreeModel extends DefaultTreeModel {
  /**
   * Creates a new model
   *
   * @param root the root node
   */
  public ExtendedTreeModel( @NotNull DefaultMutableTreeNode root ) {
    super( root );
  }

  /**
   * Registers the child
   *
   * @param parent      the parent node
   * @param childObject the chid object
   * @param index the index
   * @return the created node for the child
   */
  @NotNull
  protected DefaultMutableTreeNode addChild( @NotNull DefaultMutableTreeNode parent, @NotNull Object childObject, int index ) {
    DefaultMutableTreeNode node = new DefaultMutableTreeNode( childObject );
    insertNodeInto( node, parent, index );
    return node;
  }

  /**
   * Returns the root node
   *
   * @return the root
   */
  @Override
  public final DefaultMutableTreeNode getRoot() {
    return ( DefaultMutableTreeNode ) super.getRoot();
  }
}
