package com.cedarsoft.spring.rcp.view;

import com.cedarsoft.spring.rcp.views.ExtendedView;
import org.jetbrains.annotations.NotNull;

import java.util.Map;

/**
 * Simple configuration
 */
public class DefaultViewConfiguration implements ViewConfiguration {
  @NotNull
  private final Class<? extends ExtendedView> viewClass;
  @NotNull
  private final Map<String, Object> viewProperties;

  public DefaultViewConfiguration( @NotNull Class<? extends ExtendedView> viewClass, @NotNull Map<String, Object> viewProperties ) {
    this.viewClass = viewClass;
    //noinspection AssignmentToCollectionOrArrayFieldFromParameter
    this.viewProperties = viewProperties;
  }

  @Override
  @NotNull
  public Class<? extends ExtendedView> getViewClass() {
    return viewClass;
  }

  @Override
  @NotNull
  public Map<String, Object> getViewProperties() {
    //noinspection ReturnOfCollectionOrArrayField
    return viewProperties;
  }
}
