package com.cedarsoft.spring.rcp.view;

import com.cedarsoft.spring.rcp.views.ExtendedView;
import org.jetbrains.annotations.NotNull;

import java.util.Map;

/**
 * Configures a spring view
 */
public interface ViewConfiguration {
  /**
   * Returns the type of the view class
   *
   * @return the type of the view calss
   */
  @NotNull
  Class<? extends ExtendedView> getViewClass();

  /**
   * Returns the view properties
   *
   * @return the view properties
   */
  @NotNull
  Map<String, Object> getViewProperties();
}