package com.cedarsoft.utils.springrcp.beanlist;

import org.jetbrains.annotations.NotNull;

/**
 * <p/>
 * Date: 22.08.2006<br>
 * Time: 19:06:51<br>
 *
 * @author <a href="http://johannes-schneider.info">Johannes Schneider</a> -
 *         <a href="http://www.xore.de">Xore Systems</a>
 */
public abstract class ManagedBeanDialog<T> extends AbstractBeanDialog<T> {
  private final BeanManager<T> beanManager;

  protected ManagedBeanDialog( @NotNull BeanManager<T> beanManager, @NotNull Class<T> beanType ) {
    this.beanManager = beanManager;
  }

  @Override
  protected void beanAdded() {
    getBeanManager().add( getBean() );
  }

  @Override
  protected void saveBean() {
    getBeanManager().save( getBean() );
  }

  @NotNull
  public BeanManager<T> getBeanManager() {
    return beanManager;
  }
}
