package com.cedarsoft.utils.springrcp.beanlist;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * Implementing interfaces "know" their parent.
 * <p/>
 * Date: 24.08.2006<br>
 * Time: 18:19:21<br>
 *
 * @author <a href="http://johannes-schneider.info">Johannes Schneider</a> -
 *         <a href="http://www.xore.de">Xore Systems</a>
 */
public interface ParentAware<P> {
  /**
   * Set the new parent.
   *
   * @param parent the new parent.
   */
  void setParent( @Nullable P parent );

  @NotNull
  Class<P> getParentType();
}